import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

@immutable
abstract class ViewModelWidget<T extends ViewModelBase> {
  final T vm;

  const ViewModelWidget({required this.vm});

  @mustCallSuper
  @factory
  Widget build(BuildContext context);
}

abstract class ViewModelBase extends ChangeNotifier {
  bool loading = false;
  void setLoading() {
    loading = true;
    notifyListeners();
  }

  void setIdle() {
    loading = false;
    notifyListeners();
  }

  @mustCallSuper
  @factory
  Future<void> initState();

  ViewModelBase();
}
